#include "functions.h"

float step(float a, float x){
    return a <= x ? 1.0 : 0.0;
}

float pulse(float a, float b, float x){
    return (a <= x && x <= b) ? 1.0 : 0.0;
}

float clamp(float a, float b, float x){
    return (a <= x && x <= b) ? x - a : (x < a ? a : b);
}

float smooth(float a, float b, float x){
    if (x >= b) return 1.0;
    x = (x - a) / (b - a);
    return (x*x * (3 - 2*x));
}

float triangle(float a, float b, float c, float x){
    if (x < a or x > c) return 0.0;

    if(x < b)
        return (x - a)/(b - a);
    else
        return (x - b)/(c - b);
}
