#ifndef KERNEL_H
#define KERNEL_H

class Kernel{
    public:
        float increasingStep(float a, float t){
            return (t >= a ? 1 : 0);
        }

        float decreasingStep(float a, float t){
            return (t >= a ? 0 : 1);
        }

        float pulse(float a, float b, float t){
            return (a <= t and t <= b ? 1 : 0);
        }

        float ramp(float a, float b, float t){
            return pulse(a, b, t) * (t - a) / (b - a);
        }

        float smooth(float a, float b, float t){
            t = (t - a) / (b - a);
            return pulse(a, b, t) * t * t * (3 - t * 2);
        }
};

#endif // KERNEL_H
