#ifndef MAXIS_H
#define MAXIS_H

#include <vector>
#include <iostream>
#include <cstdlib>
#include <stdio.h>
#include <sstream>
#include <string.h>

#include "primitive.h"

using namespace std;

struct Coefficient{
    float a; 
    float b; 
    float c;
};

struct MaxisEdge{
    int line;
    int v1;
    int v2;
};

class Voronoi{

    private:
        vector< Point > vertex;
        vector< Coefficient > coeff;
//        vector< MaxisEdge > edges;

        void _executeFortunes();
        void _readOutputFile();
        void _writePoints();
        void _smooth();

    public:
        vector< MaxisEdge > edges;
        Voronoi(){};
        ~Voronoi(){};
        
        vector<Point> getVertex();
        vector< pair<Point, Point> > getEdges();
        
        void setPoints(vector<Point> points);
        void createVoronoi();
        
        void clear();
};
#endif // MAXIS_H
