#include "graphicobject.h"

/////////////////////
//  GraphicObject  //
/////////////////////

GraphicObject::GraphicObject(int _id){
    this->id = _id;

    this->r = 1.0;
    this->g = 1.0;
    this->b = 1.0;
    this->a = 1.0;
    this->size = 3;
    
    this->rotate_x = 0.0;
    this->rotate_y = 0.0;
    this->rotate_z = 0.0;

    this->translate_x = 0.0;
    this->translate_y = 0.0;
    this->translate_z = 0.0;

    this->scale_x = 1.0;
    this->scale_y = 1.0;
    this->scale_z = 1.0;
}

GraphicObject::~GraphicObject(){

}

void GraphicObject::setId(int _id){
    this->id = _id;
}

int GraphicObject::getId(){
    return this->id;
}

void GraphicObject::setColor(float _r, float _g, float _b, float _a){
    this->r = _r;
    this->g = _g;
    this->b = _b;
    this->a = _a;
}

float GraphicObject::getRed(){
    return this->r;
}

float GraphicObject::getGreen(){
    return this->g;
}

float GraphicObject::getBlue(){
    return this->b;
}

float GraphicObject::getAlpha(){
    return this->a;
}

void GraphicObject::setSize(int s){
    if (s > 0 and s < 10){
        this->size = s;
    }
}

int GraphicObject::getSize(){
    return this->size;
}

void GraphicObject::setRotateX(float rx){
    this->rotate_x = rx;
}

float GraphicObject::getRotateX(){
    return this->rotate_x;
}

void GraphicObject::setRotateY(float ry){
    this->rotate_y = ry;
}

float GraphicObject::getRotateY(){
    return this->rotate_y;
}

void GraphicObject::setRotateZ(float rz){
    this->rotate_z = rz;
}

float GraphicObject::getRotateZ(){
    return this->rotate_z;
}  

void GraphicObject::rotate(){
    glRotatef(this->rotate_x, 1.0, 0.0, 0.0);
    glRotatef(this->rotate_y, 0.0, 1.0, 0.0);
    glRotatef(this->rotate_z, 0.0, 0.0, 1.0);
}

void GraphicObject::rotate(float angle, Point direction){
    glRotatef(angle, direction.getX(), direction.getY(), direction.getZ());
}            

void GraphicObject::setTranslation(float tx, float ty, float tz){
    this->translate_x = tx;
    this->translate_y = ty;
    this->translate_z = tz;
}
void GraphicObject::setTranslateX(float tx){
    this->translate_x = tx;
}

float GraphicObject::getTranslateX(){
    return this->translate_x;
}

void GraphicObject::setTranslateY(float ty){
    this->translate_y = ty;
}

float GraphicObject::getTranslateY(){
    return this->translate_y;
}

void GraphicObject::setTranslateZ(float tz){
    this->translate_z = tz;
}

float GraphicObject::getTranslateZ(){return this->translate_z;} 


void GraphicObject::translate(){
    glTranslatef(this->translate_x, this->translate_y, this->translate_z);
} 

void GraphicObject::setScaleX(float sx){
    this->scale_x = sx;
}

float GraphicObject::setScaleX(){
    return this->scale_x;
}

void GraphicObject::setScaleY(float sy){
    this->scale_y = sy;
}

float GraphicObject::setScaleY(){
    return this->scale_y;
}

void GraphicObject::setScaleZ(float sz){
    this->scale_z = sz;
}

float GraphicObject::setScaleZ(){
    return this->scale_z;
}

void GraphicObject::scale(){
    glScalef(this->scale_x, this->scale_y, this->scale_z);
}

void GraphicObject::mode(int mode){
    switch(mode){
        case POLYGON:
            glBegin(GL_POLYGON);
            break;
        case LINE:
            glBegin(GL_LINE_STRIP);
            break;
        case POINTS:
            glBegin(GL_POINTS);
            break;
    }
}
