#ifndef TRACE_H
#define TRACE_H

#include <cstdio>
#include <cmath>
#include <vector>

#include "primitive.h"

using namespace std;

class Trace{
    protected:
        int id;
        vector<Point> points;
        
        bool ccw(Point PA, Point PB, Point PC);
        
    public:
        Trace();
        Trace(int id);
        ~Trace();
        
        void setId(int id);
        int getId();
        
        bool isEmpty();
        unsigned int size();
        void erase(int i);
        void erase(int b, int e);
        void clear();
        
        Point& operator[](int i);
        void addPoint(Point c);
        void setPoints(vector<Point> points);
        vector<Point>& getPoints();
        
        void filter(float threshold = 0.5);
        void upsample(int density);
        void smooth(int level = 10);
        
        Point getCentroide();
        void translate(Point p);
        void adjust(bool modify = false);
        void monotonize(int init, int end);
        
        void rotateXY();
        void rotateYZ();
        void rotateXZ();
};

#endif /* TRACE_H */
