//#ifndef SKELETON_H
//#define SKELETON_H

//#include <cstdio>
//#include <vector>
//#include <map>

//#include "primitive.h"

//using namespace std;

//class TopologicalVertex;

//class GeometricVertex{
//    private:
//        Point position;
//        TopologicalVertex* vertex1;
//        TopologicalVertex* vertex2;
//        
//        float weight;
//        
//    public:
//        GeometricVertex();
//        GeometricVertex(Point pos);
//        ~GeometricVertex();
//        
//        void setTopologicalVertices(TopologicalVertex* top1, TopologicalVertex* top2);
//        pair<TopologicalVertex*,TopologicalVertex*> getTopologicalVertex();
//        
//        void setPosition(Point pos);
//        Point getPosition();
//        
//        void show();
//        
//        bool operator==(Point vertex);
//        bool operator==(GeometricVertex* vertex);
//};


//class TopologicalVertex{
//    private:
//        GeometricVertex* vertex;
//        vector< vector<GeometricVertex*> > internalVertices;
//    
//    public:
//        TopologicalVertex();
//        TopologicalVertex(GeometricVertex* v);
//        ~TopologicalVertex();
//        
//        int size();
//        
//        GeometricVertex* getVertex();
//        vector< vector<GeometricVertex*> > getInternalVertices();
//        vector<Point> getAdjacentVertices();
//        
////        TopologicalVertex* getNeighbor(int internalIndex);
//        
//        void removeBranch(int i);        
//        void addBranch(vector<GeometricVertex*> branch);
//        vector<GeometricVertex*>& findBranch(GeometricVertex* vertex);
//        int getIndexBranch(GeometricVertex* vertex);
//        void show();
//        
//        bool operator==(GeometricVertex* v);
//        bool operator==(TopologicalVertex* v);
//};

//class SkeletonEdge{
//    private:
//        pair<int, int> vertices;
//        
//    public:
//        SkeletonEdge();
//        SkeletonEdge(int v1, int v2);
//        ~SkeletonEdge(){}
//        
//        void setVertex1Index(int index);
//        int getVertex1Index();

//        void setVertex2Index(int index);
//        int getVertex2Index();
//        
//        pair<int, int> getVerticesIndex();
//        
//        bool operator==(SkeletonEdge edge);
//};

//class TopologicalEdge{
//    private:
//        TopologicalVertex* vertex1;
//        TopologicalVertex* vertex2;
//        vector<GeometricVertex*> internalVertices;
//        
//    public:
//        TopologicalEdge();
//        TopologicalEdge(TopologicalVertex* vertex1, TopologicalVertex* vertex2);
//        ~TopologicalEdge();
//        
//        void setTopologicalVertex1(TopologicalVertex* v1);
//        TopologicalVertex* getTopologicalVertex1();

//        void setTopologicalVertex2(TopologicalVertex* v2);
//        TopologicalVertex* getTopologicalVertex2();
//        
//        pair<TopologicalVertex*, TopologicalVertex*> getVerticesIndex();
//        
//        void addInternalVertex(GeometricVertex* geo, bool back = true);
//        vector<GeometricVertex*> getInternalVertices();
//        
//        bool operator==(TopologicalEdge edge);
//        void show();
//};

//class Skeleton{
//    private:
//        vector< pair<TopologicalVertex*, int> > topologicalVertices;
//        vector< SkeletonEdge > edges;
//        
//        map<int, int> markup;
//        map<int, GeometricVertex*> geometricVertices;
//        
//        vector< TopologicalEdge > topologicalEdges;

//        vector<Point> geometricPoints;
//        vector< pair<Point,Point> > topologicalEdgesPoints;
//        
//        TopologicalVertex* getTopologicalVertex(GeometricVertex* v);

//        int findTopologicalVertex(TopologicalVertex* v);
//        int findTopologicalVertex(GeometricVertex* v);
//        int findGeometricVertex(GeometricVertex* v);
//        
//        vector<int> findEdge(int index);
//        int findEdge(GeometricVertex* v1, GeometricVertex* v2, bool show = false);
//        int findTopologicalEdge(GeometricVertex* v1, GeometricVertex* v2);
//        
//        void createTopologicalVertex(int topIndex);
//        void removeTopologicalVertex(int topIndex);
//        void complete();
//        void externSimplification();
//        
//        void mark();
//        
//        void updateGeometricPoints();
//        void updateTopologicalEdges();
//        void updateTopologicalEdgesPoints();

//    public:
//        Skeleton();
//        ~Skeleton();
//        
//        void addTopologicalEdge(TopologicalEdge edge);
//        void removeTopologicalEdge(int index);
////        void joinTopologicalEdges(int index1, int index2);


//        int size();
//        Point operator[](int i);
//        vector<Point> getGeometricPoints();
//        
//        vector< pair<TopologicalVertex*, int> > getTopologicalVertices(){
//            return topologicalVertices;
//        }
//        
//        vector< pair<Point,Point> > getTopologicalEdgesPoints(){
//            return topologicalEdgesPoints;
//        }
//        
//        void addEdge(Point v1, Point v2);
//        void finishSkeleton();
//        void show();
//        void edgeShow();
//};

//#endif // SKELETON_H
