#ifndef TEXTURE_H
#define TEXTURE_H

#include <stdlib.h>
#include <time.h>
#include <cmath>
#include <vector>

#include "primitive.h"

using namespace std;

#define PI 3.14159265

class LandColorize{
    protected:
        vector< vector<Point> > colorMatrix;
        int rows;
        int cols;

        float width;
        float depth;

        float widthInc;
        float depthInc;

        float peak;

    public:
        LandColorize();
        ~LandColorize();

        void setPeak(float p){peak = p;}
        float getPeak(){return peak;}

        virtual void setupColorMatrix(float width, float depth, vector< vector<float> > dem){}
        virtual Point getColor(Point p){}
};

class HillColorize : public LandColorize{
    public:
        HillColorize(){}
        ~HillColorize(){}

        void setupColorMatrix(float width, float depth, vector< vector<float> > dem);
        Point getColor(Point p);
};


class PlateuColorize : public LandColorize{
    public:
        PlateuColorize(){}
        ~PlateuColorize(){}

        void setupColorMatrix(float width, float depth, vector< vector<float> > dem);
        Point getColor(Point p);
};

class VolcanoColorize : public LandColorize{
    public:
        VolcanoColorize(){}
        ~VolcanoColorize(){}

        void setupColorMatrix(float width, float depth, vector< vector<float> > dem);
        Point getColor(Point p);
};

class IslandColorize : public LandColorize{
    public:
        IslandColorize(){}
        ~IslandColorize(){}

        void setupColorMatrix(float width, float depth, vector< vector<float> > dem);
        Point getColor(Point p);
};

#endif // TEXTURE_H
