#include "suggestion.h"

Suggestion::Suggestion(QWidget* parent) : QScrollArea(parent){
    container = new QWidget(this);
    setWidget(container);

    this->widgetWidth = 100;
    this->widgetHeight = 100;
    
    canvasId=0;
    selectedCanvas = -1;
}

Suggestion::Suggestion(int width, int height, QWidget* parent): QScrollArea(parent){
    container = new QWidget(this);
    setWidget(container);

    this->widgetWidth = width;
    this->widgetHeight = height;
    
    canvasId=0;
}

Suggestion::~Suggestion(){

}

QWidget* Suggestion::getCanvasParent(){
    return this->container;
}

void Suggestion::setupCanvas(SuggestionCanvas* canvas){
    float pos = 10 + (this->widgetWidth + 10)*this->widgets.size();
    float lenght = pos + this->widgetWidth + 10;

    canvasId++;
    canvas->setId(canvasId);
    canvas->setSuggestion(this);
    canvas->setGeometry(QRect(pos, 10, this->widgetWidth, this->widgetHeight));
    this->container->resize(lenght, height()-20);
}

void Suggestion::addSuggestion(SuggestionCanvas* canvas){
    widgets.push_back(canvas);
    for (int i = 0; i < widgets.size(); i++){
        widgets[i]->setVisible(true);
    }
}

void Suggestion::clear(){
    for (int i = 0; i < widgets.size(); i++){
        delete(widgets[i]);
    }
    widgets.clear();
}

void Suggestion::select(Point point, int canvas, int act){
    printf("%ith Canvas selected\n",canvas);
    selectedCanvas = canvas;
}

SuggestionCanvas* Suggestion::getCanvas(int index){
    return widgets[index];
}

int Suggestion::getSelectedCanvas(){
    return selectedCanvas;
}

void Suggestion::addAction(int key, Action* action){
    this->actions[key] = action;
}
