#ifndef SUGGESTION_H
#define SUGGESTION_H

#include <vector>

#include <QtGui>
#include <QWidget>
#include <QScrollArea>

#include "suggestioncanvas.h"
#include "action.h"

class Suggestion : public QScrollArea{
    protected:
        QWidget* container;
        
        int widgetWidth;
        int widgetHeight;
        
        vector<SuggestionCanvas*> widgets;
        int canvasId;
        int selectedCanvas;
        
        map<int, Action*> actions;
    
    public:
        Suggestion(QWidget* parent = 0);
        Suggestion(int width, int height, QWidget* parent = 0);
        ~Suggestion();

        QWidget* getCanvasParent();
        void setupCanvas(SuggestionCanvas* canvas);
        void addSuggestion(SuggestionCanvas* canvas);
        void clear();
        
        virtual void select(Point point, int canvas, int act = -1);
        
        SuggestionCanvas* getCanvas(int index);
        int getSelectedCanvas();
        
        void addAction(int key, Action* action);
};

#endif /* SUGGESTION_H */
