#include "myscene.h"

MyScene::MyScene(Canvas* c, Terrain* ter) : Scene(c){
    terrain = ter;
    showPlane = false;
}

MyScene::~MyScene(){

}

int MyScene::ProcessPick(GLuint selectBuff[SELECT_BUFFER_LENGTH]){

}

void MyScene::addObject(GraphicObject* object){
    this->terrain = (Terrain*) object;
}

void MyScene::setVision(int _v){
    if (vision == UP and _v == FRONT){
        for (int i = 0; i <= 800; i++){
            setRotateX(float(-i)/10.0);
            canvas->updateGL();
        }
    }
    else if (vision == FRONT and _v == UP){
        for (int i = 0; i <= 800; i++){
            setRotateX(-80.0 + float(i)/10.0);
            canvas->updateGL();
        }
    }
    else if (_v == DOWN){
       setRotateX(180.0);
       canvas->updateGL();
    }
    vision = _v;
}

void MyScene::enablePlane(){
    showPlane = true;
}

void MyScene::disablePlane(){
    showPlane = false;
}

void MyScene::setPlane(Point normal, Point center){
    plane = Plane(normal, center);
}

void MyScene::drawEnviroment(){

}

void MyScene::drawObject(int id){

}

void MyScene::drawObjects(){

}

void MyScene::draw(){
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    translate();
    rotate();
    
    glInitNames();
    glPushName(0);
    if (vision == UP){
        terrain->draw(true, false, true, false);

        glColor3f(0.0, 0.0, 0.0);
        canvas->renderText(5, 15, QString("Up Terrain"));
    }
    else if (vision == FRONT){
        terrain->draw(false, true, false, false);

        glColor3f(0.0, 0.0, 0.0);
        canvas->renderText(5, 15, QString("Front Terrain"));
    }
    else if (vision == DOWN){
        terrain->draw(false, false, false, false);
    }
    if (showPlane){
        plane.draw(1.0, 1.0, 1.0);
    }
}
