#ifndef SUGGESTION_GENERATOR_H
#define SUGGESTION_GENERATOR_H

#include <map>

#include "suggestion.h"
#include "terrain.h"
#include "action.h"
#include "mycanvas.h"

using namespace std;

#define TERRAIN_UP_GEN        1
#define TERRAIN_FRONT_GEN     2
#define IMAGE_GEN             3
#define SILHOUETTE_GEN        4

#define HAROLD_GEN              20
#define DISTANCE_HILL_GEN       21
#define NORMALIZED_HILL_GEN     22
#define MAXISDISTANCE_HILL_GEN  23
#define STEP_PLATEU_GEN         24
#define RAMP_PLATEU_GEN         25
#define SMOOTH_PLATEU_GEN       26
#define MAXIS_PLATEU_GEN        27
#define VOLCANO_GEN             28
#define ISLAND_GEN              29

#define HAROLD_EXE              40
#define DISTANCE_HILL_EXE       41
#define NORMALIZED_HILL_EXE     42
#define MAXISDISTANCE_HILL_EXE  43
#define STEP_PLATEU_EXE         44
#define RAMP_PLATEU_EXE         45
#define SMOOTH_PLATEU_EXE       46
#define MAXIS_PLATEU_EXE        47
#define VOLCANO_EXE             48
#define ISLAND_EXE              49

#define UPDATE_SILHOUETTE    201

 
class MySuggestion : public Suggestion{
    private:
        Terrain* terrain;

        int selectedCanvas;
        
        ModelingCanvas* currentCanvas;
        
    public:
        MySuggestion(int width, int height, QWidget* parent);
        ~MySuggestion();
        
        void setTerrain(Terrain* ter);
        Terrain* getTerrain();
        void setModelingCanvas(ModelingCanvas* cur);
        void select(Point point, int canvas, int act);

        void generateSuggestion(int i);
};

#endif // SUGGESTION_GENERATOR_H
